import simpleML.*;
XMLRequest xmlRequest;
String typing="";
PFont f;
boolean bSearch;
String title, author, price, description,publisher;
String[] strTitle, strAuthor, strPrice, strPublisher, strDescription, strImage;
PImage[] p;
void setup() {
  size(1024,768);
  f = createFont( "Arial" ,16,true);
  bSearch = false;
  title = "Title: ";
  author = "Author: ";
  price = "Price: ";
  description = "Description: ";
  publisher = "Publisher: ";
}

void draw(){
  background(255);
  textSetting();
  textFont(f);
  
  fill(0);
  text(typing, 200,25);
  
  if(bSearch){
    drawString();
  }  
}

void drawString(){
  int ySize = 127;
  int yHeight = 80;
  int xWidth = 180;
  if( strTitle== null) return;
  for (int i = 1; i < strTitle.length; i++ ) {
    fill(0);
    text(title + stringSplit(strTitle[i]) + "\n", xWidth,  yHeight+  ( (i-1)*ySize));
    text(author + strAuthor[i-1] + "\n", xWidth, yHeight+ 20 + ( (i-1)*ySize));
    text(price + strPrice[i-1] + "\n", xWidth, yHeight+40 + ( (i-1)*ySize));
    text(publisher + strPublisher[i-1] + "\n", xWidth, yHeight+60 + ( (i-1)*ySize));
    text(description + stringSplit(strDescription[i])+ "\n", xWidth, yHeight+ 80+ ( (i-1)*ySize));
    text("------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------",50,yHeight+ 100+( (i-1)*ySize));
    
    println(title + stringSplit(strTitle[i]));
    println(author + strAuthor[i-1]);
    println(price + strPrice[i-1]);
    println(publisher + strPublisher[i-1]);
    println(description + stringSplit(strDescription[i]));
    println("--------------------------------------------------------");
    
  }
  p = new PImage[strImage.length];
  for(int i = 0 ; i < strImage.length; i++){
    p[i] = loadImage(strImage[i]);
    image(p[i], 60 , 60 + (i * 127));
   }
}

String stringSplit(String nowString){
  String saveStr="";
  String returnStr ="";
  String[] strSplit = nowString.split("<strong>");
  
  for( int i = 0 ; i< strSplit.length ; i++){
    saveStr += strSplit[i];
  }
  strSplit = saveStr.split("</strong>");
  for( int i = 0 ; i< strSplit.length; i++){
    returnStr += strSplit[i];
  }  
  return returnStr;
}
void netEvent(XMLRequest ml){
  
  strTitle = ml.getElementArray( "title" );
  strAuthor =ml.getElementArray( "author" );
  strPrice = ml.getElementArray( "price" );
  strDescription = ml.getElementArray( "description" );
  strPublisher = ml.getElementArray( "publisher" );
  strImage =  ml.getElementArray( "image" );
  /*
  for (int i = 0; i < strTitle.length; i ++ ) {
    fill(0);
    println(strTitle[i]);
    println(strAuthor[i]);
    println(strPrice[i]);
    println(strPublisher[i]);
    println(strDescription[i]);
    println(strImage[i]);
  }
  */
}
void request(){
  //http://books.google.com/books?id=j5iTLWUUXIYC&printsec=frontcover&dq=VW+GTI&num=4&client=internal-uds&hl=ko&cd=1&source=uds#v=onepage&q&f=false
  //http://books.google.com/books?q=c&hl=en/atom+xml
  xmlRequest = new XMLRequest(this, "http://openapi.naver.com/search?key=7698a716d76852239fc9995ddc04d64c&target=book&query="+typing+"&display=5&start=1&sort=sim&hl=en" );
  //xmlRequest = new XMLRequest(this, "http://books.google.com/books?q=c&hl=en/atom+xml" );
  xmlRequest.makeRequest();
}

void textSetting(){
  textFont(f);
  fill(0);
  text("Insert Book Name :", 50,25);
  
  fill(0);
  line(0,50, width, 50);
  
}
void keyPressed(){
  if(key == '\n'){
    bSearch = true;
    request();
     typing="";
  }
  else if( key == BACKSPACE){
    typing="";
  }
  else{
    typing += key;
  }
}
