class FirstGame{
  int monsterSize = 20;
  int count = 0;
  int score = 0;
  PFont font;
  Monster[] monsters;
  User user;
  Timer t;
  int mosterMissileCount =5;
  MonsterMissile[] mm;
  boolean bGameOver;
  int LevelCount = 5;
  int LevelSpeed = 5;
  FirstGame(int nX, int nY){
   monsters = new Monster[monsterSize];
   user = new User(nX, nY, 25);
   font = loadFont("Arial-BoldMT-20.vlw");
    for(int i = 0; i < 5; i++){
     for(int j = 0; j < 4; j++){
       monsters[count] = new Monster(i*50+50, j *20+10, 15);
       count++;
     }
    }
    mm = new MonsterMissile[mosterMissileCount];
    for( int i = 0 ; i < mosterMissileCount; i++){
      mm[i] = new MonsterMissile(LevelSpeed);
    }
    t = new Timer(1000);
    t.start();
    
    bGameOver = false;;
  }
  void display(){
    
    if(bGameOver){
      gameOver();
      return;
    }
    stroke(255);
    for( int i = 0 ; i < monsterSize; i++){
      monsters[i].display();
      if(monsters[i].y > 400){
        bGameOver = true;
      }
    }
    user.display();
    if(user.bShot){
     for(int i =0; i < monsterSize; i++){
       if(monsters[i].check(user.um)){
         monsters[i].bState = false;
       user.um.bState = false;
       score += 100;
       if( score == 2000){
         bGameOver = true;
       }
       }
     } 
    }
    if( t.isFinished()){
      if( (int)random(LevelCount) == 1){
        int index = (int)random(mosterMissileCount);
        if(!mm[index].bState){
          int monsterIndex = (int)random(monsterSize);
          int x = (int)monsters[monsterIndex].x;
          int y = (int)monsters[monsterIndex].y;
          int nowSize = (int)monsters[monsterIndex].size;
          mm[index].setUp(x+ nowSize/2,y+nowSize, 10);
        }
      }
    }
    for( int i = 0 ; i < mosterMissileCount; i++){
      mm[i].display();
      if(mm[i].isCheck(user)){
        bGameOver = true;
      }
    }
    fill(0);
    textFont(font,20);
    text("Score:  "+score, 30, 460);
  }
  
  void gameOver(){
    fill( color(255,0,0));
    textFont(font,40);
    text("Game Over", 50, 100);
    text("Score : " + score, 50, 200);
  }
}

class User{
 int x, y, size;
 int xSizeLeft;
 int xSizeRight;
 UserMissile um;
 boolean bShot;
  User(int nX, int nY, int nSize){
   x = nX/2;
   y = nY-80;
   size = nSize;
   bShot = false;

  } 
  void display(){
    stroke(0);
   xSizeLeft = x-25;
   xSizeRight = x+25;
   
   if( xSizeLeft < 0){
     x = 25;
   }
   if( xSizeRight > width){
     x = width-25;
   }
   fill(color(255,0,0));
   triangle(x,y, xSizeLeft, y+15, xSizeRight, y+15);
   if(bShot){
    um.display();
    bShot = um.bState;
   }
  }
  void shot(Sample nowShot){
    if(!bShot){
     um = new UserMissile(x,y,10);
     um.setColor(0,255,0);
     bShot = true;
     nowShot.play();
    }
  }
}
class Monster{
  Timer t;
 float x, y , size;
 color c;
 boolean bState;
 Monster(int nX, int nY, int nSize){
  x = nX;
  y = nY;
  size = nSize;
  c = color( random(255),random(255),random(255));
  t = new Timer(100);
  t.start();
  bState = true;
 }
 void display(){
   if(!bState){
     x = -100;
     return;
   }
   stroke(0);
   fill(c);
   rect(x,y,size*2,size);
   if(t.isFinished()){
     y += 0.5;
     t.start();
     x += random(-1,1);
   }
 }
 boolean check(UserMissile m){
   if(m.y-m.mSize < y+size){
     if(m.x > x && m.x < x+size*2){
       return true;
     }
   }
     return false;
 }
}

class Timer {
  int savedTime; // When Timer started
  int totalTime; // How long Timer should last
  Timer(int tempTotalTime) {
    totalTime = tempTotalTime;
  }
  // Starting the timer
  void start() {
    savedTime = millis();
  }
  boolean isFinished() {
    // Check how much time has passed
    int passedTime = millis()- savedTime;
    if (passedTime > totalTime) {
      return true;
    } else {
      return false;
    }
  }
}

