class SecondGame{
  int monsterSize;
  int score = 0;
  PFont font;
  MissileMonster[] mM;
  MissileUser mUser;
  boolean bGameOver;
  boolean bIsClick;
  Timer t;
  int totalMonsterSize;
  SecondGame(int nowMonsterSize){
    monsterSize  = nowMonsterSize;
    totalMonsterSize = nowMonsterSize;
    mM = new MissileMonster[100];
    mUser = new MissileUser(10);
    font = loadFont("Arial-BoldMT-20.vlw");
    
    for( int i = 0; i < monsterSize; i++){
      mM[i] = new MissileMonster(8);
    }
    
    bGameOver = false;
    bIsClick = false;
    t = new Timer(1000);
    t.start();
  }
  
  void display(){
    if(!bIsClick){
    fill( color(255,0,0));
    textFont(font,40);
    text("Press \n'SHIFT' Key", 50, 100);
      return;
    }
    if(bGameOver){
      gameOver();
      return;
    }
    for( int i = 0 ; i < totalMonsterSize-1; i++){
      mM[i].display();
      mM[i].setColor( (int)random(255),(int)random(255),(int)random(255));
      if(mM[i].intersect(mUser)){
        if( score > 10){
          bGameOver = true;
        }
      }
    }
    mUser.display();
    
    if(t.isFinished()){
      score += 10;
      if( totalMonsterSize < 100){
        mM[totalMonsterSize] = new MissileMonster(8);
        totalMonsterSize++;
      }    
      t.start();
    }
    fill(0);
    textFont(font,20);
    text("Score:  "+score, 30, 460);
  }
  
  void gameOver(){
    fill( color(255,0,0));
    textFont(font,40);
    text("Game Over", 50, 100);
    text("Score : " + score, 50, 200);
  }
}
