import pitaru.sonia_v2_9.*;

RectButton btnFirst, btnSecond, btnBack;

FirstGame firstGame;
SecondGame secondGame;
boolean locked = false;

boolean bMenu = false;
boolean bFirstGame = false;
boolean bSecondGame = false;

int sizeX = 320;
int sizeY = 480;
int lineLocation = 430;

Sample shot;

void setup(){
 size(sizeX,sizeY);
 
 bMenu = true;
 btnFirst = new RectButton(sizeX-200  ,sizeY/2-100,100,color(50),color(0), "First");
 btnSecond = new RectButton(sizeX-200, sizeY/2 -30,100,color(50),color(0), "Second");
 btnBack = new RectButton(sizeX-100,lineLocation+3,100,color(50),color(0), "MainMenu");
 
 firstGame = new FirstGame(sizeX, sizeY);
 Sonia.start(this);
 shot = new Sample("shot.wav");
}
void draw(){
  background(255);
  stroke(0);
  line(0,lineLocation,sizeX,lineLocation);
  update(mouseX, mouseY);
  btnBack.display();
  
  if( bMenu){
    btnFirst.display();
    btnSecond.display();
    firstGame = new FirstGame(sizeX, sizeY);
    secondGame = new SecondGame(20);
  }
  if(bFirstGame){
    firstGame.display();
  }
  if(bSecondGame){
    secondGame.display();
  }  
  
}

void update(int x, int y){
 if(locked == false){
  btnFirst.update();
  btnSecond.update();
  btnBack.update();
 }
 else{
  locked = false; 
 }
 
 if(mousePressed){
   if(bMenu){ 
     if(btnFirst.pressed()){
     bMenu = false;
     bFirstGame = true;
     bSecondGame = false;   
     }
     if(btnSecond.pressed()){
      bMenu = false;
      bFirstGame = false;
      bSecondGame = true;  
     }
   }
  if( btnBack.pressed()){
    bMenu = true;
    bFirstGame = false;
    bSecondGame = false;
  }
 }
}

void keyPressed(){
  if(bFirstGame){
   if(key == CODED){
    if(keyCode == LEFT){
      firstGame.user.x -= 10;
    }
    if( keyCode == RIGHT){
     firstGame.user.x += 10; 
    }
   }
  if( key == 'a' || key == 'A'){
    firstGame.user.shot(shot);
    //shot.play();
  }
 } 
 if( bSecondGame){
   if(key == CODED){
     if(keyCode == SHIFT){
       secondGame.bIsClick = true;
     }
   }
 }
}
 
